LinuxGSM/linuxgsm.sh

380 lines
11 KiB
Bash
Raw Normal View History

2013-08-11 19:03:31 +08:00
#!/bin/bash
# Project: Game Server Managers - LinuxGSM
2013-08-11 19:03:31 +08:00
# Author: Daniel Gibbs
2017-01-08 05:15:37 +08:00
# License: MIT License, Copyright (c) 2017 Daniel Gibbs
# Purpose: Linux Game Server Management Script
# Contributors: https://github.com/GameServerManagers/LinuxGSM/graphs/contributors
# Documentation: https://github.com/GameServerManagers/LinuxGSM/wiki
2018-03-15 07:28:10 +08:00
# Website: https://linuxgsm.com
# DO NOT EDIT THIS FILE
# LinuxGSM configuration is no longer edited here
# To update your LinuxGSM config go to:
# lgsm/config-lgsm
# https://github.com/GameServerManagers/LinuxGSM/wiki/LinuxGSM-Config-Files
# Debugging
if [ -f ".dev-debug" ]; then
exec 5>dev-debug.log
BASH_XTRACEFD="5"
set -x
fi
2018-10-28 04:25:30 +08:00
version="181027"
shortname="core"
gameservername="core"
2017-10-13 05:52:47 +08:00
rootdir="$(dirname "$(readlink -f "${BASH_SOURCE[0]}")")"
selfname="$(basename "$(readlink -f "${BASH_SOURCE[0]}")")"
2017-04-09 05:21:19 +08:00
servicename="${selfname}"
lockselfname=".${servicename}.lock"
lgsmdir="${rootdir}/lgsm"
2017-04-17 05:24:53 +08:00
logdir="${rootdir}/log"
lgsmlogdir="${logdir}/lgsm"
2017-04-17 05:24:53 +08:00
steamcmddir="${rootdir}/steamcmd"
serverfiles="${rootdir}/serverfiles"
functionsdir="${lgsmdir}/functions"
libdir="${lgsmdir}/lib"
tmpdir="${lgsmdir}/tmp"
2017-04-14 20:43:45 +08:00
configdir="${lgsmdir}/config-lgsm"
configdirserver="${configdir}/${gameservername}"
2017-06-19 03:24:52 +08:00
configdirdefault="${lgsmdir}/config-default"
userinput="${1}"
2017-04-14 20:43:45 +08:00
## GitHub Branch Select
# Allows for the use of different function files
# from a different repo and/or branch.
githubuser="GameServerManagers"
githubrepo="LinuxGSM"
2017-06-19 22:09:34 +08:00
githubbranch="master"
2017-04-09 22:06:44 +08:00
2017-04-16 20:52:36 +08:00
# Core Function that is required first
2017-04-15 22:50:16 +08:00
core_functions.sh(){
functionfile="${FUNCNAME}"
2017-04-17 04:03:48 +08:00
fn_bootstrap_fetch_file_github "lgsm/functions" "core_functions.sh" "${functionsdir}" "chmodx" "run" "noforcedl" "nomd5"
2017-04-15 22:50:16 +08:00
}
2017-04-09 22:06:44 +08:00
# Bootstrap
2017-04-15 22:50:16 +08:00
# Fetches the core functions required before passed off to core_dl.sh
2013-08-11 19:03:31 +08:00
2017-04-15 22:50:16 +08:00
# Fetches core functions
fn_bootstrap_fetch_file(){
2017-04-17 04:03:48 +08:00
remote_fileurl="${1}"
local_filedir="${2}"
local_filename="${3}"
chmodx="${4:-0}"
run="${5:-0}"
2017-04-17 04:03:48 +08:00
forcedl="${6:-0}"
md5="${7:-0}"
2017-10-21 20:13:31 +08:00
# download file if missing or download forced
if [ ! -f "${local_filedir}/${local_filename}" ]||[ "${forcedl}" == "forcedl" ]; then
2017-04-17 04:03:48 +08:00
if [ ! -d "${local_filedir}" ]; then
mkdir -p "${local_filedir}"
2016-03-15 08:25:56 +08:00
fi
2017-04-17 04:16:17 +08:00
# Defines curl path
curlpath=$(command -v curl 2>/dev/null)
2017-04-09 22:06:44 +08:00
# If curl exists download file
if [ "$(basename "${curlpath}")" == "curl" ]; then
2017-04-09 22:06:44 +08:00
# trap to remove part downloaded files
echo -en " fetching ${local_filename}...\c"
2017-04-17 04:03:48 +08:00
curlcmd=$(${curlpath} -s --fail -L -o "${local_filedir}/${local_filename}" "${remote_fileurl}" 2>&1)
2017-04-09 22:06:44 +08:00
local exitcode=$?
if [ ${exitcode} -ne 0 ]; then
echo -e "FAIL"
if [ -f "${lgsmlog}" ]; then
echo -e "${remote_fileurl}" | tee -a "${lgsmlog}"
echo "${curlcmd}" | tee -a "${lgsmlog}"
2017-04-17 05:41:28 +08:00
fi
2017-04-09 22:06:44 +08:00
exit 1
else
echo -e "OK"
2017-04-09 22:06:44 +08:00
fi
else
2017-04-15 22:50:16 +08:00
echo "[ FAIL ] Curl is not installed"
2016-03-15 08:25:56 +08:00
exit 1
fi
2017-04-17 04:03:48 +08:00
# make file chmodx if chmodx is set
if [ "${chmodx}" == "chmodx" ]; then
chmod +x "${local_filedir}/${local_filename}"
2017-04-09 22:06:44 +08:00
fi
fi
2017-04-09 22:06:44 +08:00
2017-04-17 04:03:48 +08:00
if [ -f "${local_filedir}/${local_filename}" ]; then
2017-04-09 22:06:44 +08:00
# run file if run is set
if [ "${run}" == "run" ]; then
2017-04-17 04:03:48 +08:00
source "${local_filedir}/${local_filename}"
2017-04-09 22:06:44 +08:00
fi
fi
}
2017-04-17 03:20:15 +08:00
fn_bootstrap_fetch_file_github(){
github_file_url_dir="${1}"
github_file_url_name="${2}"
githuburl="https://raw.githubusercontent.com/${githubuser}/${githubrepo}/${githubbranch}/${github_file_url_dir}/${github_file_url_name}"
2017-10-21 20:13:31 +08:00
remote_fileurl="${githuburl}"
local_filedir="${3}"
local_filename="${github_file_url_name}"
2017-04-17 03:20:15 +08:00
chmodx="${4:-0}"
run="${5:-0}"
2017-10-21 20:13:31 +08:00
forcedl="${6:-0}"
2017-04-17 03:20:15 +08:00
md5="${7:-0}"
# Passes vars to the file download function
2017-10-21 20:13:31 +08:00
fn_bootstrap_fetch_file "${remote_fileurl}" "${local_filedir}" "${local_filename}" "${chmodx}" "${run}" "${forcedl}" "${md5}"
2017-04-17 03:20:15 +08:00
}
2017-04-15 22:50:16 +08:00
# Installer menu
2017-04-09 22:06:44 +08:00
2017-04-13 06:44:09 +08:00
fn_print_center() {
columns="$(tput cols)"
line="$@"
printf "%*s\n" $(( (${#line} + columns) / 2)) "${line}"
}
2017-04-15 22:50:16 +08:00
2017-04-13 06:44:09 +08:00
fn_print_horizontal(){
char="${1:-=}"
printf '%*s\n' "${COLUMNS:-$(tput cols)}" '' | tr ' ' "${char}"
}
# Bash Menu
fn_install_menu_bash() {
local resultvar=$1
title=$2
caption=$3
options=$4
fn_print_horizontal
fn_print_center "${title}"
fn_print_center "${caption}"
2017-04-13 06:44:09 +08:00
fn_print_horizontal
menu_options=()
while read -r line || [[ -n "${line}" ]]; do
var=$(echo "${line}" | awk -F "," '{print $2 " - " $3}')
menu_options+=( "${var}" )
done < ${options}
2017-04-13 06:44:09 +08:00
menu_options+=( "Cancel" )
select option in "${menu_options[@]}"; do
if [ -n "${option}" ] && [ "${option}" != "Cancel" ]; then
eval "$resultvar=\"${option/%\ */}\""
fi
break
done
}
# Whiptail/Dialog Menu
fn_install_menu_whiptail() {
local menucmd=$1
local resultvar=$2
title=$3
caption=$4
options=$5
height=${6:-40}
width=${7:-80}
menuheight=${8:-30}
IFS=","
menu_options=()
while read -r line; do
key=$(echo "${line}" | awk -F "," '{print $3}')
val=$(echo "${line}" | awk -F "," '{print $2}')
menu_options+=( ${val//\"} "${key//\"}" )
done < "${options}"
OPTION=$(${menucmd} --title "${title}" --menu "${caption}" "${height}" "${width}" "${menuheight}" "${menu_options[@]}" 3>&1 1>&2 2>&3)
2017-04-17 04:03:48 +08:00
if [ $? == 0 ]; then
2017-04-13 06:44:09 +08:00
eval "$resultvar=\"${OPTION}\""
else
eval "$resultvar="
2017-04-09 22:06:44 +08:00
fi
2017-04-13 06:44:09 +08:00
}
2017-04-09 22:06:44 +08:00
2017-04-13 06:44:09 +08:00
# Menu selector
fn_install_menu() {
local resultvar=$1
local selection=""
title=$2
caption=$3
options=$4
# Get menu command
for menucmd in whiptail dialog bash; do
if [ -x "$(command -v "${menucmd}")" ]; then
menucmd=$(command -v "${menucmd}")
2017-04-13 06:44:09 +08:00
break
fi
done
case "$(basename "${menucmd}")" in
2017-04-13 06:44:09 +08:00
whiptail|dialog)
fn_install_menu_whiptail "${menucmd}" selection "${title}" "${caption}" "${options}" 40 80 30;;
*)
fn_install_menu_bash selection "${title}" "${caption}" "${options}";;
esac
eval "$resultvar=\"${selection}\""
}
# Gets server info from serverlist.csv and puts in to array
2017-04-13 06:44:09 +08:00
fn_server_info(){
IFS=","
server_info_array=($(grep -aw "${userinput}" "${serverlist}"))
2017-04-13 06:44:09 +08:00
shortname="${server_info_array[0]}" # csgo
gameservername="${server_info_array[1]}" # csgoserver
2017-04-13 06:44:09 +08:00
gamename="${server_info_array[2]}" # Counter Strike: Global Offensive
}
fn_install_getopt(){
userinput="empty"
echo "Usage: $0 [option]"
echo -e ""
echo "Installer - Linux Game Server Managers - Version ${version}"
2018-03-15 07:28:10 +08:00
echo "https://linuxgsm.com"
2017-04-13 06:44:09 +08:00
echo -e ""
echo -e "Commands"
2017-10-21 05:06:14 +08:00
echo -e "install\t\t| Select server to install."
echo -e "servername\t| e.g $0 csgoserver. Enter name of server/game to install."
echo -e "list\t\t| List all servers available for install."
2017-04-13 06:44:09 +08:00
exit
}
fn_install_file(){
local_filename="${gameservername}"
2017-04-17 04:03:48 +08:00
if [ -e "${local_filename}" ]; then
2017-04-13 06:44:09 +08:00
i=2
2017-04-17 04:03:48 +08:00
while [ -e "${local_filename}-${i}" ] ; do
2017-04-13 06:44:09 +08:00
let i++
done
2017-04-17 04:03:48 +08:00
local_filename="${local_filename}-${i}"
2017-04-13 06:44:09 +08:00
fi
2017-04-17 04:03:48 +08:00
cp -R "${selfname}" "${local_filename}"
sed -i -e "s/shortname=\"core\"/shortname=\"${shortname}\"/g" "${local_filename}"
sed -i -e "s/gameservername=\"core\"/gameservername=\"${gameservername}\"/g" "${local_filename}"
2017-04-17 04:03:48 +08:00
echo "Installed ${gamename} server as ${local_filename}"
echo ""
if [ ! -d "${serverfiles}" ]; then
echo "./${local_filename} install"
else
echo "Remember to check server ports"
echo "./${local_filename} details"
2017-05-28 04:07:55 +08:00
fi
echo ""
2017-04-13 06:44:09 +08:00
exit
}
# Prevent LinuxGSM from running as root. Except if doing a dependency install.
2017-04-17 04:03:48 +08:00
if [ "$(whoami)" == "root" ]; then
if [ "${userinput}" == "install" ]||[ "${userinput}" == "auto-install" ]||[ "${userinput}" == "i" ]||[ "${userinput}" == "ai" ]; then
if [ "${shortname}" == "core" ]; then
echo "[ FAIL ] Do NOT run this script as root!"
exit 1
fi
elif [ ! -f "${functionsdir}/core_functions.sh" ]||[ ! -f "${functionsdir}/check_root.sh" ]||[ ! -f "${functionsdir}/core_messages.sh" ]; then
2017-04-13 06:44:09 +08:00
echo "[ FAIL ] Do NOT run this script as root!"
exit 1
else
core_functions.sh
check_root.sh
fi
2017-04-09 22:06:44 +08:00
fi
2017-04-13 06:44:09 +08:00
# LinuxGSM installer mode
if [ "${shortname}" == "core" ]; then
datadir="${tmpdir}/data"
serverlist="${datadir}/serverlist.csv"
2017-04-13 06:44:09 +08:00
# Download the latest serverlist. This is the complete list of all supported servers.
fn_bootstrap_fetch_file_github "lgsm/data" "serverlist.csv" "${datadir}" "nochmodx" "norun" "forcedl" "nomd5"
2017-05-12 06:11:04 +08:00
if [ ! -f "${serverlist}" ]; then
echo "[ FAIL ] serverlist.csv could not be loaded."
2017-04-13 06:44:09 +08:00
exit 1
fi
if [ "${userinput}" == "list" ]; then
{
awk -F "," '{print $2 "\t" $3}' "${serverlist}"
} | column -s $'\t' -t | more
exit
elif [ "${userinput}" == "install" ]||[ "${userinput}" == "i" ]; then
fn_install_menu result "LinuxGSM" "Select game to install" "${serverlist}"
2017-04-13 06:44:09 +08:00
userinput="${result}"
fn_server_info
if [ "${result}" == "${gameservername}" ]; then
2017-04-13 06:44:09 +08:00
fn_install_file
2017-04-17 03:25:30 +08:00
elif [ "${result}" == "" ]; then
echo "Install canceled"
2017-04-13 06:44:09 +08:00
else
echo "[ FAIL ] menu result does not match gameservername"
echo "result: ${result}"
echo "gameservername: ${gameservername}"
2017-04-13 06:44:09 +08:00
fi
elif [ -n "${userinput}" ]; then
fn_server_info
if [ "${userinput}" == "${gameservername}" ]||[ "${userinput}" == "${gamename}" ]||[ "${userinput}" == "${shortname}" ]; then
2017-04-13 06:44:09 +08:00
fn_install_file
else
echo "[ FAIL ] unknown game server"
2017-04-13 06:44:09 +08:00
fi
else
fn_install_getopt
fi
2017-04-16 20:52:36 +08:00
2017-04-13 06:44:09 +08:00
# LinuxGSM Server Mode
2017-04-09 22:06:44 +08:00
else
2017-04-15 22:50:16 +08:00
core_functions.sh
if [ "${shortname}" != "core-dep" ]; then
# Load LinuxGSM configs
# These are required to get all the default variables for the specific server.
# Load the default config. If missing download it. If changed reload it.
if [ ! -f "${configdirdefault}/config-lgsm/${gameservername}/_default.cfg" ]; then
mkdir -p "${configdirdefault}/config-lgsm/${gameservername}"
fn_fetch_config "lgsm/config-default/config-lgsm/${gameservername}" "_default.cfg" "${configdirdefault}/config-lgsm/${gameservername}" "_default.cfg" "nochmodx" "norun" "noforcedl" "nomd5"
2017-04-17 05:41:28 +08:00
fi
if [ ! -f "${configdirserver}/_default.cfg" ]; then
mkdir -p "${configdirserver}"
echo -en " copying _default.cfg...\c"
cp -R "${configdirdefault}/config-lgsm/${gameservername}/_default.cfg" "${configdirserver}/_default.cfg"
2017-04-17 05:41:28 +08:00
exitcode=$?
if [ ${exitcode} -ne 0 ]; then
echo -e "FAIL"
2017-04-17 05:41:28 +08:00
exit 1
else
echo -e "OK"
2017-04-17 05:41:28 +08:00
fi
else
function_file_diff=$(diff -q "${configdirdefault}/config-lgsm/${gameservername}/_default.cfg" "${configdirserver}/_default.cfg")
if [ "${function_file_diff}" != "" ]; then
fn_print_warn_nl "_default.cfg has been altered. reloading config."
echo -en " copying _default.cfg...\c"
cp -R "${configdirdefault}/config-lgsm/${gameservername}/_default.cfg" "${configdirserver}/_default.cfg"
exitcode=$?
if [ ${exitcode} -ne 0 ]; then
echo -e "FAIL"
exit 1
else
echo -e "OK"
fi
fi
fi
source "${configdirserver}/_default.cfg"
# Load the common.cfg config. If missing download it
if [ ! -f "${configdirserver}/common.cfg" ]; then
fn_fetch_config "lgsm/config-default/config-lgsm" "common-template.cfg" "${configdirserver}" "common.cfg" "${chmodx}" "nochmodx" "norun" "noforcedl" "nomd5"
source "${configdirserver}/common.cfg"
else
source "${configdirserver}/common.cfg"
fi
# Load the instance.cfg config. If missing download it
if [ ! -f "${configdirserver}/${servicename}.cfg" ]; then
fn_fetch_config "lgsm/config-default/config-lgsm" "instance-template.cfg" "${configdirserver}" "${servicename}.cfg" "nochmodx" "norun" "noforcedl" "nomd5"
source "${configdirserver}/${servicename}.cfg"
else
source "${configdirserver}/${servicename}.cfg"
2017-04-13 06:44:09 +08:00
fi
# Load the linuxgsm.sh in to tmpdir. If missing download it
if [ ! -f "${tmpdir}/linuxgsm.sh" ]; then
fn_fetch_file_github "" "linuxgsm.sh" "${tmpdir}" "chmodx" "norun" "noforcedl" "nomd5"
fi
fi
# Enables ANSI colours from core_messages.sh. Can be disabled with ansi=off
fn_ansi_loader
2017-06-21 03:43:29 +08:00
# Prevents running of core_exit.sh for Travis.
if [ "${travistest}" != "1" ]; then
getopt=$1
core_getopt.sh
fi
fi